dojo.provide("com.ibm.pb.screen.ZonedContainer");

dojo.declare("com.ibm.pb.screen.ZonedContainer",
	null,
	{
		// summary: A module that represents a set of zones over a particular DOM node
		//		and provides an API for determining which zone within the node that a set of
		//		coordinates resides in.  This is abstract and provides no implementation
		//		for mapping zones.
				
		// node: DOMNode the node to map the zones over
		node: null,
		
		constructor: function(node, params) {
			this.node = node;
		},
		getZone: function(coords) {
			// summary: Gets the unique zone number of the zone containing the coordinates 
			// 		specified by coords.  Implementations define how the zone numbers are
			// 		associated to the actual orientation of the zones on the screen.
		},
		showZoneOverlay: function() {
			if(!this.overlay) {
				var n = this.node,
					c = dojo.coords(n, true),
					z = dojo.style(n, "zIndex");
				this.overlay = dojo.create("div", {
					className: "zoneOverlay", 
					style: {
						position: "absolute",
						zIndex: dojo.style(n, "zIndex") + 1,
						top: c.y + "px",
						left: c.x + "px",
						width: c.w + "px",
						height: c.h + "px"
					}
				}, dojo.body());
				this.fillZoneOverlayContents(this.overlay);
			}
			dojo.style(this.overlay, "display", "");
		},
		hideZoneOverlay: function() {
			if(this.overlay) dojo.style(this.overlay, "display", "none");
		},
		fillZoneOverlayContents: function(node) {
			
		}
	}
);
