/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.Commitable");

dojo.require("com.ibm.mashups.enabler.Deferred");

/**
 * An interface that adds methods for checking for changes and appyling them.
 * @since 2.4
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.Commitable", null, {
    /**
     * States whether this object is &quot;dirty&quot;, meaning changes where done on this object.
     * @return {boolean} <tt>true</tt> if changes where made to the object, <tt>false</tt> otherwise.
     */
    isDirty: function(){
        return false;
    },
    
    /**
    * Commits the modifications applied to this object.<br>
    * @return {DeferredOperation} a deferred object used to start this operation. 
    * The return value when executed through the deferred object is <code>null</null>
    */
    commit: function(){
    }
});
