/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ac.AccessFactory");

dojo.require("com.ibm.mashups.enabler.ac.EffectiveAccess");
dojo.require("com.ibm.mashups.enabler.ac.VirtualResourceType");
//<INTERFACE>
/**
 * This class allows to retrieve allowed access information of nodes and virtual nodes.
 * The factory can be used using the following code: <br>
 * <code>var permission = com.ibm.mashups.enabler.ac.AccessFactory.getEffectiveAccessVirtualResource(<br/>
 * &nbsp;&nbsp;&nbsp;&nbsp;com.ibm.mashups.enabler.ac.VirtualResourceType.TEMPLATE);</code><br/>
 * @ibm-spi
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.ac.AccessFactory", null, {
    /**
     * Returns the effective allowed access for a given node. Please note that the node has
     * to be a resolved and loaded node such as NavigationNode.
     * No string or plain Identifiable is allowed.
     *
     * @param {Object} node a resolved model node such as a NavigationNode.
     * @return {com.ibm.mashups.enabler.ac.EffectiveAccess} the effective allowed access object.
     * May be <code>NULL</code> if no valid access has been found, for the given node.
     */
    getEffectiveAccess: function(node){
    },
    
    /**
     * Returns the effective allowed access for a given virtual resource.
     *
     * @param {com.ibm.mashups.enabler.ac.VirtualResourceType} resource a virtual resource type
     * @return {com.ibm.mashups.enabler.ac.EffectiveAccess} the effective access object.
     * May be <code>NULL</code> if no valid access has been found for the given virtual resource.
     */
    getEffectiveAccessVirtualResource: function(resource){
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.enabler.ac.AccessFactoryImpl");
