/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.services.WireProviderFactoryService");

//<INTERFACE>
/**
 * @private
 * @ibm-module iWidget
 */
dojo.declare("com.ibm.mashups.iwidget.services.WireProviderFactoryService",null,  {
	
	/**
	 * TODO make this public at some point, ServiceManager documentation says it should be there
	 * 
	 * @private
	 */
	SERVICE_NAME : "WireProviderFactoryService",
	
    /**
     * Creates event model for the specified widget by honoring the current persistence mode (e.g. DOM vs. Model).
     * The factory for the current persistence mode needs to be added to this service by using the <tt>addFactory</tt> method of this class.
     * 
     * @param {com.ibm.mashups.iwidget.widget.IWidgetInstance} widgetInstance the widget for which to create the wire provider
     * @param {Object} contextAndCallback an optional JSON object with a context and callback property to provide as a callback
     * @return {com.ibm.mashups.iwidget.widget.WireProvider} an event model for the specified widget using the according factory or <tt>null</tt> if no factory is available for the current mode.
     */
    createWireProvider: function(widgetWrapper, contextAndCallback) {
        
    },
    /**
     * Sets the factory for the specified persistenceMode to this service.
     * @param {String} persistenceMode the mode that is supported by the specified factory
     * @param {com.ibm.mashups.iwidget.services.WireProviderFactory} factory the factory that creates the provider.
     * @return {void}
     */
    setFactory: function(persistenceMode, factory) {
        
    },
    
    /**
     * Removes a factory for a specified persistence mode.
     * 
     * @param {String} persistenceMode the mode to remove
     * 
     * TODO make this public at some time
     * @private
     */
    removeFactory: function(persistenceMode) {
    	
    }
});
//</INTERFACE>
com.ibm.mashups.iwidget.services.WireProviderFactoryService.SERVICE_NAME = com.ibm.mashups.iwidget.services.WireProviderFactoryService.prototype.SERVICE_NAME; 
dojo.require("com.ibm.mm.iwidget.services.WireProviderFactoryServiceImpl");
